﻿using System;

namespace Zahlenketten
{
    class SquareRange : Enumerator<Int32>
    {
        Enumerator<Int32> it;
        Int32 current;

        public SquareRange(Enumerator<Int32> it)
        {
            this.it = it;
            this.current = -1;
        }

        public Int32 Current
        {
            get { return current; }
        }

        public Boolean Next()
        {
            if (it.Next())
            {
                current = it.Current * it.Current;
                return true;
            }

            return false;
        }

        public void Reset()
        {
            this.current = -1;
            this.it.Reset();
        }
    }
}
